﻿using System;
using System.Windows;
using System.Windows.Forms;
using Scylla.Common;
using Scylla.Common.Plugins;

namespace Scylla.CommonBot.Plugins
{
    /// <summary>
    /// Very simplistic pause keys extension. Going about it this way allows people to easily change the 
    /// keys they want to use for pausing the bot, or even adding some if they like.
    /// </summary>
    public class PauseKeys : IPlugin
    {
        public bool Equals(IPlugin other)
        {
            return Name == other.Name && Version == other.Version;
        }

        public string Author { get { return "Bossland GmbH"; } }
        public Version Version { get { return new Version(1, 0); } }
        public string Name { get { return "PauseKeys"; } }
        public string Description { get { return "Very simplistic pause keys extension."; } }
        public Window DisplayWindow { get { return null; } }

        public void OnPulse()
        {
        }

        public void OnInitialize()
        {
            
        }

        public void OnShutdown()
        {
        }

        public void OnEnabled()
        {
            Hotkeys.RegisterHotkey("Pause for manual play W", BotMain.ResetLastHardwareAction, Keys.W);
            Hotkeys.RegisterHotkey("Pause for manual play A", BotMain.ResetLastHardwareAction, Keys.A);
            Hotkeys.RegisterHotkey("Pause for manual play S", BotMain.ResetLastHardwareAction, Keys.S);
            Hotkeys.RegisterHotkey("Pause for manual play D", BotMain.ResetLastHardwareAction, Keys.D);

            Logging.Write("PauseKeys plugin enabled.");
        }

        public void OnDisabled()
        {
            Hotkeys.RemoveHotkey("Pause for manual play W");
            Hotkeys.RemoveHotkey("Pause for manual play A");
            Hotkeys.RemoveHotkey("Pause for manual play S");
            Hotkeys.RemoveHotkey("Pause for manual play D");

            Logging.Write("PauseKeys plugin disabled.");
        }
    }
}
